{
  description = "ECP5 toolchain template project";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
  };

  outputs = inputs@{ nixpkgs, ... }:
    let
      # litex-overlay = final: prev: {
      #   pythonPackagesExtensions = prev.pythonPackagesExtensions ++ [
      #     (python-final: python-prev: {
      #       litex = python-final.callPackage (import ./litex.nix) { };
      #       # can add more packages here!
      #     })
      #   ];
      # };
      litex-overlay = import ./litex;
      systems = [ "x86_64-linux" "aarch64-linux" "aarch64-darwin" "x86_64-darwin" ];
      forAllSystems = function:
        nixpkgs.lib.genAttrs systems (system: function (
          import nixpkgs {
            inherit system;
            config.allowUnfree = true;
            overlays = [
            ]; # patches, version pins, new pkgs here.
          }
        ));
    in {
      packages = forAllSystems (pkgs: {
        sim = import ./sim/package.nix pkgs;
      });
      devShells = forAllSystems (pkgs: {
        default = pkgs.mkShell {
          packages = with pkgs; [
            (python3.withPackages (ps: with ps; [ 
              cocotb
              amaranth
            ]))
            yosys
            nextpnr
            pkgsCross.riscv64.buildPackages.gcc
            gnumake
            wishbone-tool
            # simulators
            verilog
            verilator
            # support package
            trellis
            # loader
            openfpgaloader
            ecpdap # easier to poke probes.

            # for building the simulator
            cmake
            ninja
            mdbook
          ];
        };
      });
  };
}
